/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Contents of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.55 - (show annotations) (download)
Fri Feb 22 14:33:35 2008 UTC (6 years, 8 months ago) by hollow
Branch: MAIN
Changes since 1.54: +30 -20 lines
DRY up webapp_serverowned; extend warning messages

1 # Copyright 1999-2006 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.54 2008/02/22 14:27:17 hollow Exp $
4 #
5 # @ECLASS: webapp.eclass
6 # @MAINTAINER:
7 # web-apps@gentoo.org
8 # @BLURB: functions for installing applications to run under a web server
9 # @DESCRIPTION:
10 # The webapp eclass contains functions to handle web applications with
11 # webapp-config. Part of the implementation of GLEP #11
12
13 SLOT="${PVR}"
14 IUSE="vhosts"
15 DEPEND=">=app-admin/webapp-config-1.50.15"
16 RDEPEND="${DEPEND}"
17
18 EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
19
20 INSTALL_DIR="/${PN}"
21 IS_UPGRADE=0
22 IS_REPLACE=0
23
24 INSTALL_CHECK_FILE="installed_by_webapp_eclass"
25
26 ETC_CONFIG="${ROOT}etc/vhosts/webapp-config"
27 WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config"
28 WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner"
29
30 # ==============================================================================
31 # INTERNAL FUNCTIONS
32 # ==============================================================================
33
34 # Load the config file /etc/vhosts/webapp-config
35 # Supports both the old bash version, and the new python version
36 webapp_read_config() {
37 debug-print-function $FUNCNAME $*
38
39 if has_version '>=app-admin/webapp-config-1.50'; then
40 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
41 eval ${ENVVAR}
42 else
43 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
44 fi
45 }
46
47 # Check whether a specified file exists in the given directory (`.' by default)
48 webapp_checkfileexists() {
49 debug-print-function $FUNCNAME $*
50
51 local my_prefix=${2:+${2}/}
52
53 if [[ ! -e "${my_prefix}${1}" ]]; then
54 msg="ebuild fault: file '${1}' not found"
55 eerror "$msg"
56 eerror "Please report this as a bug at http://bugs.gentoo.org/"
57 die "$msg"
58 fi
59 }
60
61 webapp_check_installedat() {
62 debug-print-function $FUNCNAME $*
63 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
64 }
65
66 webapp_strip_appdir() {
67 debug-print-function $FUNCNAME $*
68 echo "${1#${MY_APPDIR}/}"
69 }
70
71 webapp_strip_d() {
72 debug-print-function $FUNCNAME $*
73 echo "${1#${D}}"
74 }
75
76 webapp_strip_cwd() {
77 debug-print-function $FUNCNAME $*
78 echo "${1/#.\///}"
79 }
80
81 webapp_getinstalltype() {
82 debug-print-function $FUNCNAME $*
83 use vhosts && return
84
85 local my_output
86 my_output="$(webapp_check_installedat)"
87
88 if [[ $? -eq 0 ]]; then
89 # something is already installed there
90 # make sure it isn't the same version
91
92 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
93 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
94
95 REMOVE_PKG="${my_pn}-${my_pvr}"
96
97 if [[ "${my_pn}" == "${PN}" ]]; then
98 if [[ "${my_pvr}" != "${PVR}" ]]; then
99 elog "This is an upgrade"
100 IS_UPGRADE=1
101 else
102 elog "This is a re-installation"
103 IS_REPLACE=1
104 fi
105 else
106 elog "${my_output} is installed there"
107 fi
108 else
109 elog "This is an installation"
110 fi
111 }
112
113 # ==============================================================================
114 # PUBLIC FUNCTIONS
115 # ==============================================================================
116
117 # @FUNCTION: webapp_configfile
118 # @USAGE: <file> [more files ...]
119 # @DESCRIPTION:
120 # Mark a file config-protected for a web-based application.
121 webapp_configfile() {
122 debug-print-function $FUNCNAME $*
123
124 local m
125 for m in "$@"; do
126 webapp_checkfileexists "${m}" "${D}"
127
128 local my_file="$(webapp_strip_appdir "${m}")"
129 my_file="$(webapp_strip_cwd "${my_file}")"
130
131 elog "(config) ${my_file}"
132 echo "${my_file}" >> ${D}/${WA_CONFIGLIST}
133 done
134 }
135
136 # @FUNCTION: webapp_hook_script
137 # @USAGE: <file>
138 # @DESCRIPTION:
139 # Install a script that will run after a virtual copy is created, and
140 # before a virtual copy has been removed.
141 webapp_hook_script() {
142 debug-print-function $FUNCNAME $*
143
144 webapp_checkfileexists "${1}"
145
146 elog "(hook) ${1}"
147 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
148 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
149 }
150
151 # @FUNCTION: webapp_postinst_txt
152 # @USAGE: <lang> <file>
153 # @DESCRIPTION:
154 # Install a text file containing post-installation instructions.
155 webapp_postinst_txt() {
156 debug-print-function $FUNCNAME $*
157
158 webapp_checkfileexists "${2}"
159
160 elog "(info) ${2} (lang: ${1})"
161 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
162 }
163
164 # @FUNCTION: webapp_postupgrade_txt
165 # @USAGE: <lang> <file>
166 # @DESCRIPTION:
167 # Install a text file containing post-upgrade instructions.
168 webapp_postupgrade_txt() {
169 debug-print-function $FUNCNAME $*
170
171 webapp_checkfileexists "${2}"
172
173 elog "(info) ${2} (lang: ${1})"
174 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
175 }
176
177 # helper for webapp_serverowned()
178 _webapp_serverowned() {
179 debug-print-function $FUNCNAME $*
180
181 webapp_checkfileexists "${1}" "${D}"
182 local my_file="$(webapp_strip_appdir "${1}")"
183 my_file="$(webapp_strip_cwd "${my_file}")"
184
185 elog "(server owned) ${my_file}"
186 echo "${my_file}" >> "${D}/${WA_SOLIST}"
187 }
188
189 # @FUNCTION: webapp_serverowned
190 # @USAGE: [-R] <file> [more files ...]
191 # @DESCRIPTION:
192 # Identify a file which must be owned by the webserver's user:group settings.
193 # The ownership of the file is NOT set until the application is installed using
194 # the webapp-config tool. If -R is given directories are handled recursively.
195 webapp_serverowned() {
196 debug-print-function $FUNCNAME $*
197
198 local a m
199 if [[ "${1}" == "-R" ]]; then
200 shift
201 for m in "$@"; do
202 find "${D}${m}" | while read a; do
203 a=$(webapp_strip_d "${a}")
204 _webapp_serverowned "${a}"
205 done
206 done
207 else
208 for m in "$@"; do
209 _webapp_serverowned "${m}"
210 done
211 fi
212 }
213
214 # @FUNCTION: webapp_server_configfile
215 # @USAGE: <server> <file> [new name]
216 # @DESCRIPTION:
217 # Install a configuration file for the webserver. You need to specify a
218 # webapp-config supported <server>. if no new name is given `basename $2' is
219 # used by default. Note: this function will automagically prepend $1 to the
220 # front of your config file's name.
221 webapp_server_configfile() {
222 debug-print-function $FUNCNAME $*
223
224 webapp_checkfileexists "${2}"
225
226 # WARNING:
227 #
228 # do NOT change the naming convention used here without changing all
229 # the other scripts that also rely upon these names
230
231 local my_file="${1}-${3:-$(basename "${2}")}"
232
233 elog "(${1}) config file '${my_file}'"
234 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
235 }
236
237 # @FUNCTION: webapp_sqlscript
238 # @USAGE: <db> <file> [version]
239 # @DESCRIPTION:
240 # Install a SQL script that creates/upgrades a database schema for the web
241 # application. Currently supported database engines are mysql and postgres.
242 # If a version is given the script should upgrade the database schema from
243 # the given version to $PVR.
244 webapp_sqlscript() {
245 debug-print-function $FUNCNAME $*
246
247 webapp_checkfileexists "${2}"
248
249 dodir "${MY_SQLSCRIPTSDIR}/${1}"
250
251 # WARNING:
252 #
253 # do NOT change the naming convention used here without changing all
254 # the other scripts that also rely upon these names
255
256 if [[ -n "${3}" ]]; then
257 elog "(${1}) upgrade script for ${PN}-${3} to ${PVR}"
258 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
259 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
260 else
261 elog "(${1}) create script for ${PN}-${PVR}"
262 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
263 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
264 fi
265 }
266
267 # @FUNCTION: webapp_src_preinst
268 # @DESCRIPTION:
269 # You need to call this function in src_install() BEFORE anything else has run.
270 # For now we just create required webapp-config directories.
271 webapp_src_preinst() {
272 debug-print-function $FUNCNAME $*
273
274 dodir "${MY_HTDOCSDIR}"
275 dodir "${MY_HOSTROOTDIR}"
276 dodir "${MY_CGIBINDIR}"
277 dodir "${MY_ICONSDIR}"
278 dodir "${MY_ERRORSDIR}"
279 dodir "${MY_SQLSCRIPTSDIR}"
280 dodir "${MY_HOOKSCRIPTSDIR}"
281 dodir "${MY_SERVERCONFIGDIR}"
282 }
283
284 # ==============================================================================
285 # EXPORTED FUNCTIONS
286 # ==============================================================================
287
288 # @FUNCTION: webapp_src_install
289 # @DESCRIPTION:
290 # This is the default src_install(). For now, we just make sure that root owns
291 # everything, and that there are no setuid files.
292 #
293 # You need to call this function AFTER everything else has run in your custom
294 # src_install().
295 webapp_src_install() {
296 debug-print-function $FUNCNAME $*
297
298 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
299 chmod -R u-s "${D}/"
300 chmod -R g-s "${D}/"
301
302 keepdir "${MY_PERSISTDIR}"
303 fowners "root:0" "${MY_PERSISTDIR}"
304 fperms 755 "${MY_PERSISTDIR}"
305
306 # to test whether or not the ebuild has correctly called this function
307 # we add an empty file to the filesystem
308 #
309 # we used to just set a variable in the shell script, but we can
310 # no longer rely on Portage calling both webapp_src_install() and
311 # webapp_pkg_postinst() within the same shell process
312
313 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
314 }
315
316 # @FUNCTION: webapp_pkg_setup
317 # @DESCRIPTION:
318 # The default pkg_setup() for this eclass. This will gather required variables
319 # from webapp-config and check if there is an application installed to
320 # `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set.
321 #
322 # You need to call this function BEFORE anything else has run in your custom
323 # pkg_setup().
324 webapp_pkg_setup() {
325 debug-print-function $FUNCNAME $*
326
327 # special case - some ebuilds *do* need to overwride the SLOT
328 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
329 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
330 fi
331
332 # pull in the shared configuration file
333 G_HOSTNAME="localhost"
334 webapp_read_config
335
336 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
337
338 # if USE=vhosts is enabled OR no application is installed we're done here
339 use vhosts || [[ ! -d "${my_dir}" ]] && return
340
341 local my_output
342 my_output="$(webapp_check_installedat)"
343
344 if [[ $? -ne 0 ]]; then
345 # okay, whatever is there, it isn't webapp-config-compatible
346 echo
347 ewarn
348 ewarn "You already have something installed in ${my_dir}"
349 ewarn
350 ewarn "Whatever is in ${my_dir}, it's not"
351 ewarn "compatible with webapp-config."
352 ewarn
353 ewarn "This ebuild may be overwriting important files."
354 ewarn
355 echo
356 ebeep 10
357 elif [[ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]]; then
358 echo
359 eerror "You already have ${my_output} installed in ${my_dir}"
360 eerror
361 eerror "I cannot upgrade a different application"
362 eerror
363 echo
364 die "Cannot upgrade contents of ${my_dir}"
365 fi
366 }
367
368 # @FUNCTION: webapp_pkg_postinst
369 # @DESCRIPTION:
370 # The default pkg_postinst() for this eclass. This installs the web application to
371 # `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set. Otherwise
372 # display a short notice how to install this application with webapp-config.
373 #
374 # You need to call this function AFTER everything else has run in your custom
375 # pkg_postinst().
376 webapp_pkg_postinst() {
377 debug-print-function $FUNCNAME $*
378
379 webapp_read_config
380
381 # sanity checks, to catch bugs in the ebuild
382 if [[ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]]; then
383 eerror
384 eerror "This ebuild did not call webapp_src_install() at the end"
385 eerror "of the src_install() function"
386 eerror
387 eerror "Please log a bug on http://bugs.gentoo.org"
388 eerror
389 eerror "You should use emerge -C to remove this package, as the"
390 eerror "installation is incomplete"
391 eerror
392 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
393 fi
394
395 if ! use vhosts; then
396 echo
397 elog "vhosts USE flag not set - auto-installing using webapp-config"
398
399 G_HOSTNAME="localhost"
400 webapp_read_config
401
402 local my_mode=-I
403 webapp_getinstalltype
404
405 if [[ "${IS_REPLACE}" == "1" ]]; then
406 elog "${PN}-${PVR} is already installed - replacing"
407 my_mode=-I
408 elif [[ "${IS_UPGRADE}" == "1" ]]; then
409 elog "${REMOVE_PKG} is already installed - upgrading"
410 my_mode=-U
411 else
412 elog "${PN}-${PVR} is not installed - using install mode"
413 fi
414
415 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
416 elog "Running ${my_cmd}"
417 ${my_cmd}
418
419 echo
420 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
421 einfo "Running ${cleaner}"
422 ${cleaner}
423 else
424 elog
425 elog "The 'vhosts' USE flag is switched ON"
426 elog "This means that Portage will not automatically run webapp-config to"
427 elog "complete the installation."
428 elog
429 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
430 elog
431 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
432 elog
433 elog "For more details, see the webapp-config(8) man page"
434 fi
435 }
436
437 # @FUNCTION: webapp_pkg_prerm
438 # @DESCRIPTION:
439 # This is the default pkg_prerm() for this eclass. If USE=vhosts is not set
440 # remove all installed copies of this web application. Otherwise instruct the
441 # user to manually remove those copies. See bug #136959.
442 webapp_pkg_prerm() {
443 debug-print-function $FUNCNAME $*
444
445 local my_output=
446 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
447 [[ $? -ne 0 ]] && return
448
449 local x
450 if ! use vhosts; then
451
452 for x in ${my_output}; do
453 [[ -f ${x}/.webapp ]] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
454 if [[ -n "${WEB_HOSTNAME}" && -n "${WEB_INSTALLDIR}" ]]; then
455 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
456 fi
457 done
458 else
459
460 ewarn "Don't forget to use webapp-config to remove any copies of"
461 ewarn "${PN}-${PVR} installed in"
462 ewarn
463
464 for x in ${my_output}; do
465 [[ -f ${x}/.webapp ]] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
466 ewarn " ${x}"
467 done
468 fi
469 }

  ViewVC Help
Powered by ViewVC 1.1.20